#!/usr/bin/env node
"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const index_1 = __importDefault(require("./index"));
const pkg = require('../package.json');
function apExec(options) {
    console.log(`apExect:...`, options);
}
exports.apExec = apExec;
function apExec_a_b_c(options) {
    console.log(`apExect_a_b_c:...`, options);
}
exports.apExec_a_b_c = apExec_a_b_c;
function apExec_a_b_d(options) {
    console.log(`apExect_a_b_d:...`, options);
}
exports.apExec_a_b_d = apExec_a_b_d;
function apExec_a_b_e(options) {
    console.log(`apExect_a_b_e:...`, options);
}
exports.apExec_a_b_e = apExec_a_b_e;
function apExec_a_c_a(options) {
    console.log(`apExect_a_c_a:...`, options);
}
exports.apExec_a_c_a = apExec_a_c_a;
function main() {
    const apRoot = new index_1.default({ options: { addHelp: true, description: 'argparse-tree example', version: pkg.version }, defaults: { addHelp: true } });
    {
        const apNode = apRoot;
        apRoot.parser.addArgument(['--test', '-t'], { required: false, type: 'string', dest: 'tv', help: 'test value' });
        apNode.parser.setDefaults({ execute: apExec });
    }
    {
        const apNode = apRoot.get('a').get('b').get('c');
        apNode.parser.addArgument(['--test', '-t'], { required: false, type: 'string', dest: 'tv_a_b_c', help: 'test value' });
        apNode.parser.setDefaults({ execute: apExec_a_b_c });
    }
    {
        const apNode = apRoot.get('a').get('b').get('d');
        apNode.parser.addArgument(['--test', '-t'], { required: false, type: 'string', dest: 'tv_a_b_d', help: 'test value' });
        apNode.parser.setDefaults({ execute: apExec_a_b_d });
    }
    {
        const apNode = apRoot.get('a').get('b').get('e');
        apNode.parser.addArgument(['--test', '-t'], { required: false, type: 'string', dest: 'tv_a_b_e', help: 'test value' });
        apNode.parser.setDefaults({ execute: apExec_a_b_e });
    }
    {
        const apNode = apRoot.get('a').get('c').get('a');
        apNode.parser.addArgument(['--test', '-t'], { required: false, type: 'string', dest: 'tv_a_c_a', help: 'test value' });
        apNode.parser.setDefaults({ execute: apExec_a_c_a });
    }
    const options = apRoot.parser.parseArgs(process.argv.slice(2));
    console.log(`options = `, options);
    console.log(`selectedParts = `, apRoot.getSelectedPathArray(options));
    console.log(`selectedPath = `, apRoot.getSelectedPath(options));
    options.execute(options);
}
exports.main = main;
main();
//# sourceMappingURL=example.js.map