import * as argparse from 'argparse';
export { argparse };
export interface ArgumentParserNodeInterface {
    name?: string;
    readonly subparsers: argparse.SubParser;
    readonly level: number;
    readonly pathArray: string[];
    readonly path: string;
    get(name: string, options?: argparse.ArgumentParserOptions): ArgumentParserNodeInterface;
}
export declare type ArgumentParserNodeOptions = {
    options: argparse.ArgumentParserOptions;
    defaults: argparse.ArgumentParserOptions;
    subparserOptions?: argparse.SubparserOptions;
} & ({
    parent: ArgumentParserNode;
    name: string;
} | {});
export declare class ArgumentParserNode implements ArgumentParserNodeInterface {
    name?: string;
    parent?: ArgumentParserNode;
    root?: ArgumentParserNode;
    defaultOptions: argparse.ArgumentParserOptions;
    subparserOptions: argparse.SubparserOptions;
    parser: argparse.ArgumentParser;
    children: {
        [key: string]: ArgumentParserNode;
    };
    _subparsers: argparse.SubParser | undefined;
    static subparserRegex: RegExp;
    constructor(options: ArgumentParserNodeOptions);
    get(name: string, options?: argparse.ArgumentParserOptions): ArgumentParserNode;
    readonly subparsers: argparse.SubParser;
    static getSelectedPathArray(options: any): string[];
    getSelectedPathArray(options: any): string[];
    static getSelectedPath(options: any): string;
    getSelectedPath(options: any): string;
    readonly level: number;
    readonly pathArray: string[];
    readonly path: string;
}
export declare type ArgumentParserTree = ArgumentParserNode;
export declare const ArgumentParserTree: typeof ArgumentParserNode;
export default ArgumentParserTree;
