#!/usr/bin/env node

//import { ArgumentParserNode as ArgParseTree } from './index';
import ArgParseTree from './index';
const pkg = require('../package.json');

export function apExec(options: any) {
	console.log(`apExect:...`, options);
}

export function apExec_a_b_c(options: any) {
	console.log(`apExect_a_b_c:...`, options);
}

export function apExec_a_b_d(options: any) {
	console.log(`apExect_a_b_d:...`, options);
}

export function apExec_a_b_e(options: any) {
	console.log(`apExect_a_b_e:...`, options);
}

export function apExec_a_c_a(options: any) {
	console.log(`apExect_a_c_a:...`, options);
}

export function main() {
	const apRoot = new ArgParseTree( { options: { addHelp: true, description: 'argparse-tree example', version: pkg.version }, defaults: { addHelp: true } } );
	{
		const apNode = apRoot;
		apRoot.parser.addArgument([ '--test', '-t' ], {required: false, type: 'string', dest: 'tv', help: 'test value'});
		apNode.parser.setDefaults({execute: apExec});
	}
	{
		const apNode = apRoot.get('a').get('b').get('c');
		apNode.parser.addArgument([ '--test', '-t' ], {required: false, type: 'string', dest: 'tv_a_b_c', help: 'test value'});
		apNode.parser.setDefaults({execute: apExec_a_b_c});
	}
	{
		const apNode = apRoot.get('a').get('b').get('d');
		apNode.parser.addArgument([ '--test', '-t' ], {required: false, type: 'string', dest: 'tv_a_b_d', help: 'test value'});
		apNode.parser.setDefaults({execute: apExec_a_b_d});
	}
	{
		const apNode = apRoot.get('a').get('b').get('e');
		apNode.parser.addArgument([ '--test', '-t' ], {required: false, type: 'string', dest: 'tv_a_b_e', help: 'test value'});
		apNode.parser.setDefaults({execute: apExec_a_b_e});
	}
	{
		const apNode = apRoot.get('a').get('c').get('a');
		apNode.parser.addArgument([ '--test', '-t' ], {required: false, type: 'string', dest: 'tv_a_c_a', help: 'test value'});
		apNode.parser.setDefaults({execute: apExec_a_c_a});
	}
	const options = apRoot.parser.parseArgs(process.argv.slice(2));
	console.log(`options = `, options);
	console.log(`selectedParts = `, apRoot.getSelectedPathArray(options));
	console.log(`selectedPath = `, apRoot.getSelectedPath(options));
	options.execute(options);
}

main();
